using Gtk;
using Granite;


namespace Eidete.Widgets{

	public class Countdown : Granite.Widgets.CompositedWindow {

		public Label count;
		public int time;

		public Countdown (){
			this.time = 5;

			this.set_default_size (300, 200);
			this.window_position = WindowPosition.CENTER;
			this.set_keep_above (true);
			this.stick ();
			this.type_hint = Gdk.WindowTypeHint.SPLASHSCREEN;
			this.skip_pager_hint = true;
			this.skip_taskbar_hint = true;

			var box = new Box (Orientation.VERTICAL, 0);
			box.margin = 40;
			box.margin_left = box.margin_right = 60;

			var title = new Label ("<span size='20000' color='#fbfbfb'>"+_("Recording starts in")+"…"+"</span>");
			title.use_markup = true;
			title.margin_bottom = 20;

			this.count = new Label ("<span size='40000' color='#fbfbfb'>"+time.to_string ()+"</span>");
			this.count.use_markup = true;

			var tipp = new Label("<span size='10000' color='#fbfbfb' font-style='italic'>"+_("Focus Eidete to stop recording")+"</span>");
			tipp.use_markup = true;
			tipp.margin_top = 20;

			box.pack_start (title);
			box.pack_start (count);
			box.pack_start (tipp);

			this.add (box);
		}

		public override bool draw (Cairo.Context ctx){
			int w = this.get_allocated_width  ();
			int h = this.get_allocated_height ();
			Granite.Drawing.Utilities.cairo_rounded_rectangle (ctx, 4, 4, w-8, h-8, 4);
			ctx.set_source_rgba (0.1, 0.1, 0.1, 0.8);
			ctx.fill ();
			return base.draw (ctx);
		}

		public void start (EideteApp app){

			this.show_all ();
			Timeout.add (1000, () => {
				this.time --;
				count.label = "<span size='40000' color='#fbfbfb'>"+time.to_string ()+"</span>";
				if (time == -1){
					this.destroy ();
					Timeout.add (100, () => { //let the countdown disappear before starting
					    app.record ();
					    app.main_window.iconify ();
					    app.switch_to_paused (false);
					    return false;
				    });
				    return false;
				}
				return true;
			});
		}

	}


}


