#include <stdio.h>
#include <glib.h>
#include <X11/Xproto.h>
#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include <X11/extensions/record.h> //libxtst-dev, Xtst
#include <gstreamer-0.10/gst/gst.h>
#include <gstreamer-0.10/gst/gstinterface.h>
/*
GList *list_devices (){
	GstElement *pulsesrc = gst_element_factory_make ("pulsesrc", "src");
	GList *list = gst_property_probe_get_properties (pulsesrc);
	return list;
}
*/

static Display* dpy = 0;
static XRecordContext rc;

void key_pressed_cb(XPointer arg, XRecordInterceptData *d) {
	if (d->category != XRecordFromServer) return;

    xEvent* event = (xEvent*)d->data;
    
	unsigned char type = ((unsigned char*)d->data)[0] & 0x7F;
	unsigned char detail = ((unsigned char*)d->data)[1];
    unsigned int shiftlevel = 0;

    if( event->u.keyButtonPointer.state == 0 ||
        event->u.keyButtonPointer.state == 1 ) {
        shiftlevel = event->u.keyButtonPointer.state;
    }
	
	switch (type) {
	    case KeyPress:
		    g_signal_emit_by_name (arg, "captured", XKeysymToString (XkbKeycodeToKeysym (dpy, detail, 0, shiftlevel)), FALSE);
		    break;
	    case KeyRelease:
		    g_signal_emit_by_name (arg, "captured", XKeysymToString (XkbKeycodeToKeysym (dpy, detail, 0, shiftlevel)), TRUE);
		    break;
        case ButtonPress:
            g_signal_emit_by_name (arg, "captured-mouse", event->u.keyButtonPointer.rootX, event->u.keyButtonPointer.rootY, event->u.u.detail);
            break;
        case MotionNotify:
            g_signal_emit_by_name (arg, "captured-move", event->u.keyButtonPointer.rootX, event->u.keyButtonPointer.rootY);
            break;
	    default:
	        break;
	}
}

void* intercept_key_thread (void *data) {
	XRecordClientSpec rcs;
	XRecordRange* rr;
	dpy = XOpenDisplay (0);
	
	XKeysymToString (XkbKeycodeToKeysym (dpy, 11, 1, 0));
	
	if (!(rr = XRecordAllocRange())) {
		fprintf(stderr, "XRecordAllocRange error\n");
	}
	rr->device_events.first = KeyPress;
	rr->device_events.last = MotionNotify;
	rcs = XRecordAllClients;
	
	if (!(rc = XRecordCreateContext(dpy, 0, &rcs, 1, &rr, 1))) {
		fprintf(stderr, "XRecordCreateContext error\n");
	}
	XFree(rr);
	if (!XRecordEnableContext(dpy, rc, key_pressed_cb, data)) {
		fprintf(stderr, "XRecordEnableContext error\n");
	}
	return 0;
}

