using Gtk;

public static void main (string [] args){
	Gtk.init (ref args);
	
	var source = File.new_for_uri (args[1]);
	
	var file = new FileChooserDialog (_("Save"), null, FileChooserAction.SAVE, Stock.OK, ResponseType.OK);
	file.set_current_name (source.get_basename ());
	file.do_overwrite_confirmation = true;
	var res = file.run ();
	if (res == ResponseType.OK){
		var destination = File.new_for_path (file.get_filename ());
		try{
			source.copy (destination, FileCopyFlags.OVERWRITE);
		}catch (GLib.Error e){stderr.printf ("Error: %s\n", e.message);}
		
		file.destroy ();
		Gtk.main_quit ();
	}else{
		file.destroy ();
	}
	
	Gtk.main ();
}

